//#################################################################################################//
//#                                                                                               #// 
//#  **** Schneider Engineering, Bad Vilbel ***                                                   #//
//#  **** Inh.  Dipl.-Ing. Peter Schneider  ***                                                   #//
//#                                                                                               #//
//#  Filename : bug2Defaults.h                                                                    #//
//#  Project  : Odemetrie                                                                         #//
//#                                                                                               #//
//#                                                                                               #//    
//#  Odemetrie mit BUG2 Pathfindig Algorithmus ein moeglicher Implementierungsvorschlag           #// 
//#  Quelle des Algorithmus www.wikipedia.de                                                      #//
//#                                                                                               #//
//#  (c) Peter Schneider (Schneider Engineering software / hardware development)                  #//
//#  www.ps-robotics.com                                                                          #//
//#                                                                                               #//
//#  Version:                                                                                     #//         
//#  1.03       14 August 2011 11:39       Original release                                       #//
//#                                                                                               #//
//#  This program is free software; you can redistribute it and/or modify                         #//
//#  it under the terms of the GNU General Public License as published by                         #//
//#  the Free Software Foundation; either version 2 of the License, or                            #//
//#  (at your option) any later version.                                                          #//
//#                                                                                               #//		
//#  This program is distributed in the hope that it will be useful,                              #//
//#  but WITHOUT ANY WARRANTY; without even the implied warranty of                               #//	
//#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                                #//	
//#  GNU General Public License for more details.                                                 #//
//#                                                                                               #//
//#  You should have received a copy of the GNU General Public License                            #//
//#  along with this program; if not, write to peter.schneider@ps-robotics.de                     #//
//#                                                                                               #//
//#################################################################################################//
//

#ifndef	DEFAULTS_H
#define	DEFAULTS_H


/*  ********** Globale Variablen *********** */
#define        NULL          0
#define        FWD           3
#define        BWD           4
#define        LEFT          1
#define        RIGHT         2



#define        xl             2                     // Matrix   X-Achse  low
#define        xh             40                    // Matrix   X-Achse  high
#define        yl             2                     // Matrix   Y-Achse  low
#define        yh             20                    // Matrix   Y-Achse  high

#define        Start_X        2	                   // Startpunkt x, Y
#define        Start_Y        8

#define        Ziel_X         30                    // Zielpunkt  x, Y
#define        Ziel_Y         8

int            X_coursor_alt;
int            Y_coursor_alt;
int            X_coursor_ist;
int            Y_coursor_ist;

int            X;
int            Y;

int            sensor_mitte  = FALSE;
int            sensor_links  = FALSE;
int            sensor_rechts = FALSE;

int            move_dir      = 3;   // entscpricht FWD
int            last_dir      = 3;   // entscpricht FWD




int            matrix [xh+2] [yh+2];                // Matrix mit Start, Zielpunkt und Hindernisse
int            db_query;                            // Datenbank Query


// ********************** Gewichtsmartix ***********************************
// in dieser Matrix wird die Reaktion auf Zustaende der Sensoren gespeichert
// einfach gesagt, was soll der Roboter tun wenn Zustand x an den Sensoren anliegt
// Vorraussetzung, dass Hindernis wird  IMMER  recht herum umfahren !!!
//
int            gewicht [25][10] =                   // 1=LEFT, 2=RIGHT, 3=FWD, 4=BWD 
               {          
                  {0,1,0,3,3,5,6,2,3},
                  {0,0,0,2,3,6,5,3,2},
                  {0,0,0,3,2,5,4,1,3},
                  {0,0,0,3,1,5,4,1,3},
                  {0,0,0,1,3,4,5,4,1},
                  {0,0,0,4,1,5,6,2,4},
                  {0,0,0,2,4,6,5,3,2},
                  {1,0,0,1,3,5,4,1,3},
                  {1,0,0,1,4,5,4,1,4},
                  {1,0,0,2,3,5,6,2,3},
                  {1,0,0,2,4,5,6,2,4},
                  {1,0,0,3,2,6,5,3,2},
                  {1,0,0,3,1,6,5,3,1},
                  {1,0,0,4,2,4,5,4,2},
                  {1,0,0,4,1,4,5,4,1},
                  {1,1,0,1,4,6,5,3,1},
                  {1,1,0,2,3,4,5,4,2},
                  {1,1,0,4,2,5,4,1,4},
                  {1,1,0,2,4,4,5,4,1},
                  {1,1,0,3,2,5,6,2,3},
                  {1,1,0,4,4,4,5,1,4},
                  {0,0,0,1,4,4,5,4,1},
                  {1,1,1,4,1,6,5,3,4},
                  {0,0,0,3,4,5,4,1,3},
                  {1,1,0,1,3,6,5,3,1}
               };



#endif // DEFAULTS_H